#case
#include <16F690.h>
#device *=16
#device adc=10

#FUSES INTRC_IO
#FUSES NOWDT
#FUSES NOPUT
#FUSES NOMCLR
#FUSES NOPROTECT
#FUSES NOCPD
#FUSES NOBROWNOUT
#FUSES NOIESO
#FUSES NOFCMEN

#use delay(clock=8000000,RESTART_WDT)

#use fast_io(C)

#ROM 0x2100 = {
   0xD0, 0x07,             // STARTUP Temperature (200)
   0x00,                   // UNUSED
   0x1E,                   // HYSTERESIS (3)
   0x00,                   // DS
   0xED, 0xFF,             // OFFSET (-19)
   0x80, 0x5B, 0x6D, 0xB7, // SLOPE (3.428571429)
   0xFF, 0xFF, 0xFF, 0xFF  // UNUSED
}








struct lcd_pin_map {                
           BOOLEAN unused;  
           BOOLEAN rs;
           BOOLEAN rw;
           BOOLEAN enable;
           int     data : 4;
        } lcd;

#define HEATER_ON() {lcd.unused = 0;}
#define HEATER_OFF() {lcd.unused = 1;}

//BUTTONS - GND == idle, VDD == pressed
#define ENCODER1 PIN_A1
#define ENCODER2 PIN_A2
#define ENCODERB PIN_A4

#define BAR_DELAY 15

#locate lcd = getenv("sfr:PORTC")
#define set_tris_lcd(x) set_tris_c(x)
#define lcd_type 2
#define lcd_line_two 0x40   

BYTE const LCD_INIT_STRING[4] = {0x20 | (lcd_type << 2), 0xc, 1, 6};
struct lcd_pin_map const LCD_WRITE = {0,0,0,0,0}; 
struct lcd_pin_map const LCD_READ = {0,0,0,0,15};

BYTE lcd_read_byte() {
      BYTE low,high;
      set_tris_lcd(LCD_READ);
      lcd.rw = 1;
      delay_cycles(1);
      lcd.enable = 1;
      delay_cycles(1);
      high = lcd.data;
      lcd.enable = 0;
      delay_cycles(1);
      lcd.enable = 1;
      delay_us(1);
      low = lcd.data;
      lcd.enable = 0;
      set_tris_lcd(LCD_WRITE);
      return( (high<<4) | low);
}

void lcd_send_nibble( BYTE n ) {
      lcd.data = n;
      delay_cycles(1);
      lcd.enable = 1;
      delay_us(2);
      lcd.enable = 0;
}


void lcd_send_byte( BYTE address, BYTE n ) {
      lcd.rs = 0;
      while ( bit_test(lcd_read_byte(),7) ) ;
      lcd.rs = address;
      delay_cycles(1);
      lcd.rw = 0;
      delay_cycles(1);
      lcd.enable = 0;
      lcd_send_nibble(n >> 4);
      lcd_send_nibble(n & 0xf);
}


void lcd_init() {
    BYTE i;
    set_tris_lcd(LCD_WRITE);
    lcd.rs = 0;
    lcd.rw = 0;
    lcd.enable = 0;
    delay_ms(15);
    for(i=1;i<=3;++i) {
       lcd_send_nibble(3);
       delay_ms(5);
    }
    lcd_send_nibble(2);
    for(i=0;i<=3;++i)
       lcd_send_byte(0,LCD_INIT_STRING[i]);
}

void lcd_gotoxy(BYTE x, BYTE y)
{
   BYTE address;
  
   if(y!=1)
      address=lcd_line_two;
   else
      address=0;
     
   address+=x-1;
   lcd_send_byte(0,0x80|address);
}

void lcd_putc(char c)
{
   switch (c)
   {
      case '\a'   :  lcd_gotoxy(1,1);     break;
      case '\f'   :  lcd_send_byte(0,1);
                     delay_ms(2);
                     break;
      case '\n'   : lcd_gotoxy(1,2);        break;
      case '\b'   : lcd_send_byte(0,0x10);  break;
      default     : lcd_send_byte(1,c);     break;
   }
}
